*** src/ssl_stubs.c	Sat Dec 18 03:03:54 2004
--- src/ssl_stubs.c.new	Fri Jun  3 19:10:18 2005
***************
*** 383,388 ****
--- 383,389 ----
  CAMLprim ocaml_ssl_read_certificate(value vfilename)
  {
    CAMLparam1(vfilename);
+   CAMLlocal1(block);
    char *filename = String_val(vfilename);
    X509 *cert = NULL;
    FILE *fh = NULL;
***************
*** 396,402 ****
        raise_constant(*caml_named_value("ssl_exn_certificate_error"));
      }
  
-   CAMLlocal1(block);
    block = alloc_final(2, finalize_cert, sizeof(X509*), sizeof(X509*));
    Field(block, 1) = (value)cert;
    CAMLreturn(block);
--- 397,402 ----
***************
*** 405,417 ****
  CAMLprim value ocaml_ssl_get_certificate(value socket)
  {
    CAMLparam1(socket);
  
    X509 *cert = SSL_get_peer_certificate(ssl_socket_of_block(socket)->handler);
  
    if (cert == NULL)
       raise_constant(*caml_named_value("ssl_exn_certificate_error"));
  
-   CAMLlocal1(block);
    block = alloc_final(2, finalize_cert, sizeof(X509*), sizeof(X509*));
    Field(block, 1) = (value)cert;
    CAMLreturn(block);
--- 405,417 ----
  CAMLprim value ocaml_ssl_get_certificate(value socket)
  {
    CAMLparam1(socket);
+   CAMLlocal1(block);
  
    X509 *cert = SSL_get_peer_certificate(ssl_socket_of_block(socket)->handler);
  
    if (cert == NULL)
       raise_constant(*caml_named_value("ssl_exn_certificate_error"));
  
    block = alloc_final(2, finalize_cert, sizeof(X509*), sizeof(X509*));
    Field(block, 1) = (value)cert;
    CAMLreturn(block);
